<h3>Registrar Ventas</h3>
<!-- <form #form> -->
<div class="form-row ">
    <div class="col-md-5 mb-2">
        <div class="input-group input-group-sm">
            <span class="input-group-text" style="min-width: 100px;">Tipo de Venta</span>
            <select class="form-control form-select form-select-sm" [(ngModel)]="tipo_venta" name="tipo_venta" [ngClass]="{'form-control':true,'is-invalid': form.submitted && tipo_venta == ''}">
                    <option selected disabled>Seleccione el Tipo de Venta</option>
                    <option [value]="tipo_venta.acronimo_tipo_venta" *ngFor="let tipo_venta of catalogo_tipo_venta">{{tipo_venta.descripcion}}</option>
                </select>
            <div class="invalid-feedback">Seleccione el Tipo de Venta</div>
        </div>
    </div>
    <div class="col-md-2 mb-2">
        <div class="input-group input-group-sm">
            
        </div>
    </div>
    <div class="col-md-5 mb-2">
        <div class="input-group input-group-sm">
            <span class="input-group-text" style="width: 100px;">Fecha</span>
            <input type="date" class="form-control" [(ngModel)]="fecha_venta" name="fecha_venta" aria-describedby="inputGroupPrepend2" [ngClass]="{'form-date':true,'is-invalid': form.submitted && fecha_venta==''}" required>
            <div class="invalid-feedback">La Fecha es Obligatorio</div>
        </div>
    </div>
</div>
<form [formGroup]="form_registro_venta" (ngSubmit)="agregarVenta(form_registro_venta)" #form="ngForm">
<!-- <form (submit)="agregarVenta(form)" #form="ngForm" novalidate> -->
    
    <div class="form-row ">
        <div class="col-md-4 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="min-width: 100px;">Forma Pago</span>
                <select class="form-control form-select form-select-sm" formControlName="sat_forma_pago" [ngClass]="{'is-invalid': form.submitted && form_registro_venta.controls.sat_forma_pago.errors}">
                        <option selected disabled>Seleccione la Forma de Pago</option>
                        <option [value]="forma_pago.acronimo_forma_pago" *ngFor="let forma_pago of catalogo_forma_pago">{{forma_pago.descripcion}}</option>
                    </select>
                <div class="invalid-feedback">Forma de Pago es Obligatorio</div>
            </div>
        </div>
        <div class="col-md-4 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">Cantidad</span>
                <input type="text" class="form-control" NumbersOnlyDirective formControlName="cantidad" aria-describedby="inputGroupPrepend2" [ngClass]="{'is-invalid': form.submitted && form_registro_venta.value.cantidad <= 0}">
                <div class="invalid-feedback">{{this.form_registro_venta.value.cantidad == undefined ? 'Cantidad es Obligatorio y' : 'La Cantidad'}} Debe Ser Mayor a 0</div>
            </div>
        </div>

        <div class="col-md-4 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">Identificador</span>
                <input type="text" class="form-control" formControlName="identificador" aria-describedby="inputGroupPrepend2">
                <div class="invalid-feedback"></div>
            </div>
        </div>
    </div>

    <div class="form-row ">
        <div class="col-md-12 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">Concepto</span>
                <input type="text" class="form-control" formControlName="concepto" aria-describedby="inputGroupPrepend2" [ngClass]="{'is-invalid': form.submitted && form_registro_venta.controls.concepto.errors}">
                <div class="invalid-feedback">Concepto no puede estar vacío</div>
            </div>
        </div>
    </div>
    <div class="form-row ">
        <div class="col-md-4 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">Unidad</span>
                <input type="text" class="form-control" formControlName="unidad" aria-describedby="inputGroupPrepend2" [ngClass]="{'is-invalid': form.submitted && form_registro_venta.controls.unidad.errors}">
                <div class="invalid-feedback">Unidad no puede estar vacío</div>
            </div>
        </div>
        <div class="col-md-4 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">Clave Unidad</span>
                <input type="text" class="form-control" formControlName="sat_clave_unidad" list="catalogo_claves_unidad" aria-describedby="inputGroupPrepend2" [ngClass]="{'is-invalid': form.submitted && form_registro_venta.controls.sat_clave_unidad.errors}">
                <datalist id="catalogo_claves_unidad">
                    <option [value]="elemento.clave_unidad" *ngFor="let elemento of getClaveUnidadFiltrado()" >{{elemento.descripcion}}</option>
                </datalist>
                <div class="invalid-feedback">Clave Unidad no puede estar vacío</div>
            </div>
        </div>
        <div class="col-md-4 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">ClaveProdServ</span>
                <input type="text" class="form-control" formControlName="sat_claveprodserv" list="catalogo_claves_productos_servicios" aria-describedby="inputGroupPrepend2" [ngClass]="{'is-invalid': form.submitted && form_registro_venta.controls.sat_claveprodserv.errors }"
                    required>
                <datalist id="catalogo_claves_productos_servicios">
                    <option [value]="elemento.clave_producto_servicio" *ngFor="let elemento of getClaveProductoervicioFiltrado()" >{{elemento.descripcion}}</option>
                </datalist>
                <div class="invalid-feedback">Clave Producto Servicio no puede estar vacío</div>
            </div>
        </div>
    </div>
    <div class="form-row ">
        <div class="col-md-4 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">Precio U.</span>
                <input type="text" class="form-control" formControlName="precio_unitario" aria-describedby="inputGroupPrepend2" [ngClass]="{'is-invalid': form.submitted && form_registro_venta.value.precio_unitario <= 0 }" required>
                <div class="invalid-feedback" *ngIf="this.form_registro_venta.value.precio_unitario <= 0">Precio Unitario debe ser mayor a 0</div>
            </div>
        </div>
        <div class="col-md-4 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">IVA</span>
                <input type="checkbox" class="btn-check" id="btn-check-2-outlined" checked autocomplete="off" formControlName="aplica_iva">
                <label class="btn btn-outline-success" for="btn-check-2-outlined" style="margin-bottom: 0;" ngbTooltip="Se aplica IVA al importe">{{form_registro_venta.value.aplica_iva ? "Si":"No"}}</label>

                <input type="checkbox" class="btn-check" id="btn-check-outlined" autocomplete="off" formControlName="incluye_iva" *ngIf="form_registro_venta.value.aplica_iva">
                <label class="btn btn-outline-primary" for="btn-check-outlined" style="margin-bottom: 0;" ngbTooltip="El Precio {{form_registro_venta.value.incluye_iva ? 'Ya':'No'}} incluye IVA" *ngIf="form_registro_venta.value.aplica_iva">{{form_registro_venta.value.incluye_iva ? "":"No"}} Incluye IVA</label>
                <div class="invalid-feedback" *ngIf="this.form_registro_venta.value.precio_unitario <= 0">Precio Unitario debe ser mayor a 0</div>
            </div>
        </div>
        <div class="col-md-4 mb-2" *ngIf="!form_registro_venta.value.incluye_iva">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">Descuento</span>
                <input type="text" class="form-control" formControlName="descuento" value="{{form_registro_venta.value.descuento | number:'1.2-2'}}" aria-describedby="inputGroupPrepend2" required>
                <div></div>
            </div>
        </div>
        <div class="col-md-4 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">Importe</span>
                <input type="text" class="form-control" formControlName="importe" value="{{(form_registro_venta.value.cantidad * form_registro_venta.value.precio_unitario)-(form_registro_venta.value.incluye_iva ? 0 : form_registro_venta.value.descuento) | number:'1.2-2'}}" aria-describedby="inputGroupPrepend2" readonly>
                <div></div>
            </div>
        </div>
        <div class="col-md-4 mb-2" *ngIf="!form_registro_venta.value.incluye_iva">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">Importe + IVA</span>
                <input type="text" class="form-control" value="{{((form_registro_venta.value.cantidad * form_registro_venta.value.precio_unitario)-(form_registro_venta.value.incluye_iva ? 0 : form_registro_venta.value.descuento))*(1 + (form_registro_venta.value.aplica_iva ? tasa_iva : 0)) | number:'1.2-2'}}" aria-describedby="inputGroupPrepend2" readonly>
                <div></div>
            </div>
        </div>
    </div>

    <div class="form-row">
        <div class="mb-2" *ngIf="posicion != -2">
            <div class="input-group input-group-sm">
                <button class="btn btn-danger" (click)="limpiarVenta()" type="button">
                    Cancelar
                </button>
            </div>
        </div>
        &nbsp;
        <div class="mb-2">
            <div class="input-group input-group-sm">
                <button class="btn btn-primary">
                    {{this.posicion==-1 ? "Agregar Venta" : "Guardar" }}
                </button>
            </div>
        </div>
        &nbsp;
    </div>

</form>

<div class="table-responsive" *ngIf="true">

    <div class="btn-toolbar" role="toolbar">
        <div class="table-responsive">

            <table [ngClass]="{'table':true,'table-hover': registro_ventas.length != 0}" id="tabla">
                <thead>
                    <tr>
                        <th><small><b>Acciones</b></small></th>
                        <th><small><b>#</b></small></th>
                        <th><small><b>Cantidad</b></small></th>
                        <th><small><b>Descripcion</b></small></th>
                        <th><small><b>Unidad</b></small></th>
                        <th><small><b>Precio Unitario</b></small></th>
                        <th><small><b>Descuento</b></small></th>
                        <th><small><b>Importe</b></small></th>
                        <th><small><b>IVA</b></small></th>
                        <th><small><b>Total</b></small></th>
                    </tr>
                </thead>
                <tbody *ngIf="registro_ventas.length == 0">
                    <tr>
                        <td colspan="10" align="center">Sin Registros</td>
                    </tr>
                </tbody>
                <tbody>
                    <tr *ngFor="let venta of registro_ventas;let i=index ">
                        <td>
                            <button class="btn btn-danger btn-sm" (click)="eliminarVenta(i)"><i class="bi bi-trash-fill"></i></button>
                            <button class="btn btn-primary btn-sm" (click)="modificarVenta(i)"><i class="bi bi-pencil-square"></i></button>
                        </td>
                        <td><small>{{(i+1) | number}}</small></td>
                        <td align="right"><small>{{venta.cantidad | number}}</small></td>
                        <td><small>{{venta.concepto}}</small></td>
                        <td><small>{{venta.unidad}}</small></td>
                        <td align="right"><small>{{venta.precio_unitario | currency}}</small></td>
                        <td align="right"><small>{{venta.descuento | currency}}</small></td>
                        <td align="right"><small>{{venta.importe | currency}}</small></td>
                        <td align="right"><small>{{venta.importe_iva | currency}}</small></td>
                        <td align="right"><small>{{venta.importe+venta.importe_iva | currency}}</small></td>
                    </tr>
                </tbody>
                <tr *ngIf="registro_ventas.length > 0">
                    <td></td>
                    <th colspan="4" style="text-align: right"><small><b>Subtotal</b></small></th>
                    <th style="text-align: right">{{getTotal("precio_unitario") | currency}}</th>
                    <th style="text-align: right">{{getTotal("descuento") | currency}}</th>
                    <th style="text-align: right">{{getTotal("importe") | currency}}</th>
                    <th style="text-align: right">{{getTotal("importe_iva") | currency}}</th>
                    <th style="text-align: right">{{getTotal("importe") + getTotal("importe_iva") | currency}}</th>
                    <!-- <th style="text-align: right">{{ registro_ventas.map(venta => venta.importe).reduce( (a, b) => a + b,0 ) }}</th> -->
                </tr>
            </table>
        </div>
    </div>
</div>
<div class="mb-2" *ngIf="registro_ventas.length>0">
    <div class="input-group input-group-sm">
        <button class="btn btn-success" type="button" (click)="registrarVenta()">
            Registrar Venta
        </button>
    </div>
</div>
<link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
<div class="container">
    <div class="row">
        <div class="col-md-8 offset-md-2">
            <button mat-raised-button>Pressh !!</button>
        </div>
    </div>
</div>
<section>
    <div class="example-label">Basic</div>
    <div class="example-button-row">
      <button mat-button>Basic</button>
      <button mat-button color="primary">Primary</button>
      <button mat-button color="accent">Accent</button>
      <button mat-button color="warn">Warn</button>
      <button mat-button disabled>Disabled</button>
      <a mat-button href="https://www.google.com/" target="_blank">Link</a>
    </div>
  </section>